/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_PRODFILI                                                */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao de produto por filial                */
/*                                                                            */
/* Criao:                                                                   */
/* 21/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODFILI'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_PRODFILI
  GO

CREATE TRIGGER DTULTATU_PRODFILI
ON PRODFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODFILI', CDFILIAL, 'CDFILIAL=' + CDFILIAL +
                                             ';CDPRODUTO='+ CDPRODUTO +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      IF ((SELECT MAX(ISNULL(IDPRODATIV,'A')) FROM INSERTED) = 'I') BEGIN
         UPDATE PRODFILI
         SET DTULTATUPRFIL = GETDATE()
         FROM INSERTED
         WHERE
          ISNULL(PRODFILI.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0)   AND
          ISNULL(PRODFILI.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0);
       END
       ELSE BEGIN
	      UPDATE PRODUTO
			 SET DTULTATUPROD = GETDATE()
			FROM INSERTED
		   WHERE ISNULL(PRODUTO.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0);
          
		  INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                  (SELECT 'PRODFILI', CDFILIAL, 'CDFILIAL=' + CDFILIAL +
                                                ';CDPRODUTO='+ CDPRODUTO +';', GETDATE() FROM INSERTED)
       END;
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODFILI','4.09.081';
GO